/****************************************************************
*  The Finite Field Fourier Transform							*
*																*
*  By Lucia L.-Bartosova										*
*****************************************************************/

#include <iostream>
#include <stdio.h>
#include <time.h>
#include <NTL/ZZ_p.h>
#include <NTL/ZZ_pE.h>
#include <NTL/ZZ_pEX.h>
#include <NTL/ZZ_pXFactoring.h>
#include <NTL/matrix.h>
#include <NTL/mat_ZZ_p.h>
#include <NTL/vec_ZZ_p.h>

#define BIT(X,I)	( ((X) >> I) & 0x0001 )

NTL_CLIENT

int main()
{

		char exit[10];
		while(strcmp(exit,"exit")!=0)
		{


	cout<<"The Finite Field Fourier Transform"<<endl;
	cout<<"**********************************"<<endl<<endl;

	cout<<"Konecne pole GF(p)"<<endl;
	cout<<"Zadaj p: ";
	int p;
//	long n;
	cin>>p;
//	cout<<"Zadaj n: ";
//	cin>>n;
	cout<<endl;


//--definition of GF(p)
	ZZ_p::init(to_ZZ(p));
	cout<<"Pomocou prikazu ZZ_p::init(p) definujeme pole GF(p)."<<endl;
	
//--definition of irreducible polynomial of degree n over GF(p)
//	ZZ_pX P;				

//	BuildIrred(P, n);
//	cout<<"Pomocou funkcie BuildIrred sme vytvorili ireducibilny polynom stupna n."<<endl;
//	cout<<"NTL ho vypise vo forme vektora. Koeficienty polynomu su usporiadane od a_0...a_n, a_n != 0."<<endl;
//	cout<<P<<endl;

//--definition of GF(p^n)
//	ZZ_pE::init(P);
//	cout<<"Pomocou prikazu ZZ_pE::init(P) definujeme pole GF(p^n)."<<endl;

//--counting of primitive element (generator) of the GF
	cout<<endl<<"V prvom kroku urcime generator pola."<<endl;
	ZZ_p gen;
	bool test=true;
	for (int i=1; i<p; i++){
		test=true;
		for (int j=1; j<(p-1); j++){
			if( power(to_ZZ_p(i),j) ==1){
				cout<<"Prvok "<<i<<" nie je generator, ord je "<<j<<"."<<endl;
				j=p-1;
				test=false;
			}
		}
		
		if ((power(to_ZZ_p(i),p-1) ==1) && (test == true)){
				gen=i;
				break;
		}		
	}



	cout<<"Generator pola je prvok: "<<gen<<endl<<endl;

//--count matrix of fourier transformation
	cout<<"V druhom kroku urcime matice fourierovej transformacie."<<endl<<endl;
	mat_ZZ_p mat_fft;
	mat_fft.SetDims(p-1,p-1);
	for (i=0; i<p-1; i++){
		for(int j=0; j<p-1; j++){
			mat_fft[i][j]=power(gen, i*j);
			cout<<"a^"<<to_ZZ_p(i*j)<<"\t";
		}
		cout<<endl;
	}
	cout<<endl<<mat_fft<<endl<<endl;

//--multiply matrix by a vector
	vec_ZZ_p in, out;
	in.SetLength(p-1);
	out.SetLength(p-1);
	cout<<"Zadaj vektor dlzky "<<p-1<<" v tvare [a_0 .. a_"<<p-2<<"] : ";
	cin>>in;
//	solve(determinant(mat_fft), out, mat_fft, in);
	out=in*mat_fft;
	cout<<"Po vynasobeni zadaneho vektora a matice dostavame: "<<endl;
	cout<<out<<endl;

        cout<<endl<<endl;
		cout<<"***************************************";
		cout<<"***************************************";
		cout<<endl<<endl;
		cout<<"Na ukoncenie zadaj 'exit', inak 'cont'."<<endl;
		cin>>exit;
		}


	return 0;
}